       *>
       *> Micro Focus Server Express XA switch module for Oracle.
       *>
       *> (C) Copyright 2005-2007 Micro Focus (IP) Limited
       *> All Rights Reserved.
       *>

       IDENTIFICATION DIVISION.
       PROGRAM-ID. ESORAXA.
       ENVIRONMENT DIVISION.

       DATA DIVISION.
       WORKING-STORAGE SECTION.

       01 OraXaPtr      USAGE PROCEDURE-POINTER VALUE NULL.
       01 XASwitchPtr   REDEFINES OraXaPtr USAGE POINTER.
       01 MFocusCasPtr  USAGE PROCEDURE-POINTER VALUE NULL.
       01 BadPtr        USAGE PROCEDURE-POINTER VALUE NULL.
       01 SubpPtr       USAGE PROCEDURE-POINTER VALUE NULL.

       *> Database Access structure used by Enterprise Server.

       78 78-XA-ONEPHASE-SUPPORT              VALUE H'80000000'.

       01 esoraxa-dbaccess-struct.
          03 esoraxa-xa-structure.
             05 esoraxa-RM-name               PIC X(32).
      $IF P64 SET
             05 esoraxa-flags                 PIC S9(18) COMP-5.
             05 esoraxa-version               PIC S9(18) COMP-5.
      $ELSE
             05 esoraxa-flags                 PIC S9(9) COMP-5.
             05 esoraxa-version               PIC S9(9) COMP-5.
      $END
             05 esoraxa-open-entry            PROCEDURE-POINTER.
             05 esoraxa-close-entry           PROCEDURE-POINTER.
             05 esoraxa-start-entry           PROCEDURE-POINTER.
             05 esoraxa-end-entry             PROCEDURE-POINTER.
             05 esoraxa-rollback-entry        PROCEDURE-POINTER.
             05 esoraxa-prepare-entry         PROCEDURE-POINTER.
             05 esoraxa-commit-entry          PROCEDURE-POINTER.
             05 esoraxa-recover-entry         PROCEDURE-POINTER.
             05 esoraxa-forget-entry          PROCEDURE-POINTER.
             05 esoraxa-complete-entry        PROCEDURE-POINTER.
       78 78-XA-STRUCTURE-LEN                 VALUE
                               NEXT - START OF esoraxa-xa-structure.
             05 esoraxa-1phase.
                07 esoraxa-1phase-flags            PIC X(8).
                07 esoraxa-1phase-connect-entry    PROCEDURE-POINTER.
                07 esoraxa-1phase-disconnect-entry PROCEDURE-POINTER.
                07 esoraxa-1phase-commit-entry     PROCEDURE-POINTER.
                07 esoraxa-1phase-rollback-entry   PROCEDURE-POINTER.
       78 78-XA-DBACCESS-STRUCT-LEN           VALUE
                               NEXT - START OF esoraxa-xa-structure.

       *> Structure holding entry points returned by call to Oracle
       *> function, xaosw.

       01 ORAXAStructure.
             05 ORAXA-open-entry              PROCEDURE-POINTER.
             05 ORAXA-close-entry             PROCEDURE-POINTER.
             05 ORAXA-start-entry             PROCEDURE-POINTER.
             05 ORAXA-end-entry               PROCEDURE-POINTER.
             05 ORAXA-rollback-entry          PROCEDURE-POINTER.
             05 ORAXA-prepare-entry           PROCEDURE-POINTER.
             05 ORAXA-commit-entry            PROCEDURE-POINTER.
             05 ORAXA-recover-entry           PROCEDURE-POINTER.
             05 ORAXA-forget-entry            PROCEDURE-POINTER.
             05 ORAXA-complete-entry          PROCEDURE-POINTER.

       *> Set up names for internal entry points for each XA
       *> function.

       78 esxa-ep-prefix                 VALUE "ESORA".

          78 esxa-open 
                  VALUE esxa-ep-prefix & "ESXA_OPEN".
          78 esxa-close 
                  VALUE esxa-ep-prefix & "ESXA_CLOSE".
          78 esxa-start 
                  VALUE esxa-ep-prefix & "ESXA_START".
          78 esxa-end 
                  VALUE esxa-ep-prefix & "ESXA_END".
          78 esxa-rollback 
                  VALUE esxa-ep-prefix & "ESXA_ROLLBACK".
          78 esxa-prepare 
                  VALUE esxa-ep-prefix & "ESXA_PREPARE".
          78 esxa-commit 
                  VALUE esxa-ep-prefix & "ESXA_COMMIT".
          78 esxa-recover 
                  VALUE esxa-ep-prefix & "ESXA_RECOVER".
          78 esxa-forget 
                  VALUE esxa-ep-prefix & "ESXA_FORGET".
          78 esxa-complete 
                  VALUE esxa-ep-prefix & "ESXA_COMPLETE".

       *> Return codes for XA calls

       01 ws-return-flags.
          03 ws-open-rc                 PIC S9(9) COMP-5 VALUE 0.
          03 ws-close-rc                PIC S9(9) COMP-5 VALUE 0.
          03 ws-start-rc                PIC S9(9) COMP-5 VALUE 0.
          03 ws-end-rc                  PIC S9(9) COMP-5 VALUE 0.
          03 ws-rollback-rc             PIC S9(9) COMP-5 VALUE 0.
          03 ws-prepare-rc              PIC S9(9) COMP-5 VALUE 0.
          03 ws-commit-rc               PIC S9(9) COMP-5 VALUE 0.
          03 ws-recover-rc              PIC S9(9) COMP-5 VALUE 0.
          03 ws-forget-rc               PIC S9(9) COMP-5 VALUE 0.
          03 ws-complete-rc             PIC S9(9) COMP-5 VALUE 0.

       *> Data definitions for Consolidated Tracing Facility.

       COPY "cbltypes.cpy".

       COPY "mfctf.cpy".

       01  CasLoadString                      PIC X(80) VALUE SPACES.
       01  OraLoadString                      PIC X(80) VALUE SPACES.
       01  XaoswString                        PIC X(80) VALUE SPACES.
       01  TmpString                          PIC X(80) VALUE SPACES.

       78  MAX-TRACE-DATA                     VALUE 5.
       78  THIS-COMPONENT                     VALUE "MF.ESORA".

      *----------------------------------------------------------------
      *    THIS_COMPONENT's tracer properties
      *----------------------------------------------------------------
       78  PROPID-ALL                         VALUE 1.

       78  PROPNAME-ALL                       VALUE "all".
       78  PROPNAME-CASLOAD                   VALUE "casload".
       78  PROPNAME-ORALOAD                   VALUE "oraload".
       78  PROPNAME-XAOSW                     VALUE "xaosw".

       01  ws-prop-names.
           03                         PIC X(10) VALUE PROPNAME-ALL.
           03                         PIC X(10) VALUE PROPNAME-CASLOAD.
           03                         PIC X(10) VALUE PROPNAME-ORALOAD.
           03                         PIC X(10) VALUE PROPNAME-XAOSW.
           03                         PIC X(10) VALUE spaces.
       01  ws-prop-name               REDEFINES ws-prop-names
                                      PIC X(10) OCCURS 5.
      *----------------------------------------------------------------
      *    THIS_COMPONENT events
      *----------------------------------------------------------------
       78  EVENT-CASLOAD               VALUE 0.
       78  EVENT-ORALOAD               VALUE 1.
       78  EVENT-XAOSW                 VALUE 2.

      *----------------------------------------------------------------
      *    Trace flags for THIS-COMPONENT. Each bit of these flags
      *    corresponds to a property being set (non-zero value) for 
      *    THIS-COMPONENT. The actual bit set for a given property
      *    corresponds to the position-1 of the property's name in the
      *    'ws-prop-name' table above. For example, if bit 0 is set,
      *    it indicates that the 'APPLES' property was set. If the 'ALL'
      *    property is set, then all bits of 'trace_flags' will be set.
      *
      *    N.B. This is just an example of how properties and their
      *    values may be processed by a component.How properties are
      *    processed is completely transparent to CTF.
      *----------------------------------------------------------------
       78  TRACE-FLAGS-CASLOAD         VALUE h'00000001'.
       78  TRACE-FLAGS-ORALOAD         VALUE h'00000002'.
       78  TRACE-FLAGS-XAOSW           VALUE h'00000004'.

       01  ctf-config-data.
           03  ctf-trace-level         PIC X(4) COMP-5.
           03  ctf-trace-flags         PIC X(4) COMP-5.

      *----------------------------------------------------------------
      *    Variables required for CTF event generation
      *----------------------------------------------------------------
       01  ctf-event-data.
           03  ctf-tracer-handle       PIC X(4) COMP-5.
           03  ctf-trace-event         cblt-trc-event.
           03  ctf-trace-event-lens    PIC X(4) comp-5
                                       OCCURS MAX-TRACE-DATA.
           03  ctf-trace-event-types   PIC X(4) comp-5
                                       OCCURS MAX-TRACE-DATA.
           03  ctf-trace-event-ptrs    pointer
                                       OCCURS MAX-TRACE-DATA.

       local-storage section.
       01  ls-data.
           03  ls-api-flags            PIC X(4) COMP-5.
           03  ls-bunch-size           PIC X(4) COMP-5.
           03  ls-comp-name            PIC X(16).
           03  ls-install-param        cblt-trc-notif-install.
           03  ls-net-size             PIC X(4) COMP-5.
           03  ls-prop-id              PIC X(4) COMP-5.
           03  ls-prop-value           PIC X(4) COMP-5.
           03  ls-trace-data-count     PIC X(4) COMP-5.
           03  ls-trace-data-desc      PIC X(80).
           03  ls-trace-start-desc     PIC X(14).
           03  ls-trace-event          PIC X(4) COMP-5.
           03  ls-trace-level          PIC X(4) COMP-5.
           03  ls-work-var             PIC X(4) COMP-5.

       LINKAGE SECTION.

       *> Tracing support

       01  lk-ctf-tracer-handle        PIC X(4) COMP-5.
       01  lk-ctf-notif-type           PIC X(4) COMP-5.

       01  lk-ctf-notif-param          PIC X.
       01  lk-ctf-notif-param-level    REDEFINES lk-ctf-notif-param
                                       PIC X(4) COMP-5.
       01  lk-ctf-notif-param-property REDEFINES lk-ctf-notif-param
                                       cblt-trc-notif-prop-change.
       01  lk-ctf-property-name        PIC X.
       01  lk-ctf-property-value       PIC X.

       01  lk-switch-area              PIC X.

       *> Parameters required for XA function entry points.

       01  lk-xid.
           03 lk-xid-formatid          PIC S9(9) COMP-5.
              88 lk-xid-nullxid-88     VALUE -1.
           03 lk-xid-gtrid-length      PIC S9(9) COMP-5.
           03 lk-xid-bqual-length      PIC S9(9) COMP-5.
           03 lk-xid-value.
              05 lk-xid-global.
                 07 lk-xid-id          PIC X(6).
                 07 lk-xid-sysid       PIC X(4).
                 07 lk-xid-tran-no     PIC 9(6).
              05 lk-xid-branch-no      PIC 9(6).
              05                       PIC X(105).

       01 lk-rmid                      PIC S9(9) COMP-5.
       01 lk-flags                     PIC S9(9) COMP-5.
       01 lk-open-string               PIC X.
       01 lk-close-string              PIC X.
       01 lk-rc                        PIC S9(9) COMP-5.

       PROCEDURE DIVISION.

          PERFORM initialise-ora-tracing

          *> Load Enterprise Server module
          SET MFocusCasPtr TO ENTRY "casaxlib.so"

          IF (TRACE-FLAGS-CASLOAD b-and ctf-trace-flags) NOT = 0
             AND 78-CTF-FLAG-LEVEL-INFO >= ctf-trace-level
               MOVE EVENT-CASLOAD          TO ls-trace-event
               MOVE 78-CTF-FLAG-LEVEL-INFO TO ls-trace-level
               PERFORM trace-ora-event
          END-IF

          *> Attempt to load a pointer to the Oracle XA switch structure
          SET OraXaPtr TO ENTRY "xaosw"

          IF (TRACE-FLAGS-XAOSW b-and ctf-trace-flags) NOT = 0
             AND 78-CTF-FLAG-LEVEL-INFO >= ctf-trace-level
               MOVE EVENT-XAOSW            TO ls-trace-event
               MOVE 78-CTF-FLAG-LEVEL-INFO TO ls-trace-level
               PERFORM trace-ora-event
          END-IF

          IF XASwitchPtr NOT = NULL
               SET ADDRESS OF lk-switch-area TO XASwitchPtr
               move LK-SWITCH-AREA(1:78-XA-STRUCTURE-LEN)
                                       TO esoraxa-xa-structure

               *> Save off entry points as returned by call to
               *> Oracle function, xaosw.

               MOVE esoraxa-open-entry        TO ORAXA-open-entry
               MOVE esoraxa-close-entry       TO ORAXA-close-entry
               MOVE esoraxa-start-entry       TO ORAXA-start-entry
               MOVE esoraxa-end-entry         TO ORAXA-end-entry
               MOVE esoraxa-rollback-entry    TO ORAXA-rollback-entry
               MOVE esoraxa-prepare-entry     TO ORAXA-prepare-entry
               MOVE esoraxa-commit-entry      TO ORAXA-commit-entry
               MOVE esoraxa-recover-entry     TO ORAXA-recover-entry
               MOVE esoraxa-forget-entry      TO ORAXA-forget-entry
               MOVE esoraxa-complete-entry    TO ORAXA-complete-entry

               *> Update the structure passed back to Enterprise
               *> Server to utilise local entry points within this
               *> module.

               SET esoraxa-open-entry         TO ENTRY esxa-open
               SET esoraxa-close-entry        TO ENTRY esxa-close
               SET esoraxa-start-entry        TO ENTRY esxa-start
               SET esoraxa-end-entry          TO ENTRY esxa-end
               SET esoraxa-rollback-entry     TO ENTRY esxa-rollback
               SET esoraxa-prepare-entry      TO ENTRY esxa-prepare
               SET esoraxa-commit-entry       TO ENTRY esxa-commit
               SET esoraxa-recover-entry      TO ENTRY esxa-recover
               SET esoraxa-forget-entry       TO ENTRY esxa-forget
               SET esoraxa-complete-entry     TO ENTRY esxa-complete

               *> Attempt to load one-phase commit module, for
               *> JES-initiated transactions.

               SET SubpPtr TO ENTRY "ESORAOPC.so"

               *> If loaded successfully, update the XA structure
               *> to set up the appropriate procedure pointers for
               *> handling JES-initiated transactions.

               IF SubpPtr NOT = NULL
                  SET esoraxa-1phase-commit-entry
                                  TO ENTRY 'esoraopc_1pc_commit'    
                  SET esoraxa-1phase-rollback-entry  
                                  TO ENTRY 'esoraopc_1pc_rollback'
                  SET esoraxa-1phase-connect-entry
                                  TO ENTRY 'esoraopc_1pc_connect'
                  SET esoraxa-1phase-disconnect-entry
                                  TO ENTRY 'esoraopc_1pc_disconnect'
                  COMPUTE esoraxa-flags = 
                       esoraxa-flags B-OR 78-XA-ONEPHASE-SUPPORT
               END-IF
               SET XASwitchPtr TO ADDRESS OF esoraxa-dbaccess-struct
           END-IF


          GOBACK RETURNING OraXaPtr
          .

      *****************************************************************
      *  Initialise tracing for THIS-COMPONENT.
      *
      *  On exit from this section 'ctf-tracer-handle',
      *  'ctf-trace-flags' and 'ctf-trace-level' will be set for
      *  THIS-COMPONENT
      *****************************************************************
       initialise-ora-tracing section.

           MOVE 0 TO ctf-trace-flags

           *>
           *>  Pick up THIS-COMPONENT's tracer handle
           *>
           MOVE 78-CTF-FLAG-COMP-NAME-NULL-TERM TO ls-api-flags
           MOVE THIS-COMPONENT & x"00" TO ls-comp-name

           CALL "CBL_CTF_TRACER_GET" USING
                                     BY VALUE     ls-api-flags
                                     BY REFERENCE ls-comp-name
                                     BY REFERENCE ctf-tracer-handle
           END-CALL

           IF RETURN-CODE NOT = 0
               DISPLAY "CBL_CTF_TRACER_GET (rc = "
                       RETURN-CODE
                       ")"
               EXIT SECTION
           END-IF

           *>
           *>  Get THIS-COMPONENT's tracer properties.
           *>
           *>  For the purpose of this demo, all properties are
           *>  expected to have integer values, so if the property
           *>  exists, but has a non-integer value it will be ignored.
           *>
           MOVE 78-CTF-FLAG-PROP-INT-VALUE TO ls-api-flags

           PERFORM VARYING ls-prop-id FROM 1 BY 1
                     UNTIL ws-prop-name(ls-prop-id) = SPACES

               CALL "CBL_CTF_COMP_PROPERTY_GET" USING
                              BY VALUE     ls-api-flags
                              BY REFERENCE ctf-tracer-handle
                              BY REFERENCE ws-prop-name(ls-prop-id)
                              BY VALUE     0
                              BY REFERENCE ls-prop-value
               END-CALL

               IF RETURN-CODE = 0
                   PERFORM apply-ora-property-value
               END-IF
           END-PERFORM

           *>
           *>  Get THIS-COMPONENT's tracer trace level
           *>
           MOVE 0 TO ls-api-flags

           CALL "CBL_CTF_TRACER_LEVEL_GET" USING
                                       BY VALUE     ls-api-flags
                                       BY REFERENCE ctf-tracer-handle
                                       BY REFERENCE ctf-trace-level
           END-CALL

           IF RETURN-CODE NOT = 0
               DISPLAY "CBL_TRACER_LEVEL_GET (rc = "
                       return-code
                       ")"
               EXIT SECTION
           END-IF

           *>
           *> Install tracer notification callback
           *>
           MOVE LOW-VALUES TO ls-install-param
           MOVE ctf-tracer-handle TO
                cblte-tni-handle OF ls-install-param
           SET cblte-tni-callback OF ls-install-param TO
               ENTRY "ctf-tracer-ora-notif-callback"

           CALL "CBL_CTF_TRACER_NOTIFY" USING
                                        BY VALUE 0
                                        BY REFERENCE ls-install-param
           END-CALL

           IF RETURN-CODE NOT = 0
               DISPLAY "CBL_CTF_TRACER_NOTIFY (rc = "
                       return-code
                       ")"
               EXIT SECTION
           END-IF

           *>
           *> Initialise fixed fields in trace event structure
           *>
           MOVE LOW-VALUES TO ctf-trace-event

           SET cblte-trcevt-event-len OF ctf-trace-event TO
               ADDRESS OF ctf-trace-event-lens(1)
           SET cblte-trcevt-event-type OF ctf-trace-event TO
               ADDRESS OF ctf-trace-event-types(1)
           SET cblte-trcevt-event-data OF ctf-trace-event TO
               ADDRESS OF ctf-trace-event-ptrs(1)
           .

      *****************************************************************
      *    Set appropriate trace flags bit
      *****************************************************************
       apply-ora-property-value section.
           IF ls-prop-id = PROPID-ALL
               IF ls-prop-value NOT = 0
                  COMPUTE ctf-trace-flags = ctf-trace-flags b-or
                                            h'FFFFFFFF'
               ELSE
                  MOVE 0 TO ctf-trace-flags
               END-IF
           ELSE
               COMPUTE ls-work-var = 2 ** (ls-prop-id - 2)

               IF ls-prop-value NOT = 0
                   COMPUTE ctf-trace-flags = ctf-trace-flags b-or
                                             ls-work-var
               ELSE
                   COMPUTE ctf-trace-flags = ctf-trace-flags b-and b-not
                                             ls-work-var
               END-IF
           END-IF
           .

      *****************************************************************
      *  THIS-COMPONENT tracer callback. Processes THIS-COMPONENT's
      *  property and trace level changes.
      *
      *  lk-ctf-tracer-handle  =  tracer handle
      *
      *  lk-ctf-notif-type     =  notification type
      *
      *                           0 = property change
      *                           1 = trace level change
      *
      *  lk-ctf-notif-info     =  address of item whose type is
      *                           dependent upon notification type
      *
      *                           type 0 = cblt-trc-notif-prop-change
      *                           type 1 = pic x(4) comp-5
      *****************************************************************
       ctf-tracer-ora-notif-callback section.
           ENTRY "ctf-tracer-ora-notif-callback" USING
                                      BY VALUE     lk-ctf-tracer-handle
                                      BY VALUE     lk-ctf-notif-type
                                      BY REFERENCE lk-ctf-notif-param.
           EVALUATE lk-ctf-notif-type
               WHEN 78-TRC-NOTIF-TYPE-PROP-CHANGE
                   PERFORM ctf-tracer-ora-notif-property

               WHEN 78-TRC-NOTIF-TYPE-LEVEL-CHANGE
                   MOVE lk-ctf-notif-param-level TO ctf-trace-level

               WHEN OTHER
                    CONTINUE
           END-EVALUATE

           GOBACK
           .

      *-----------------------------------------------------------------
      *    Tracer property changed
      *-----------------------------------------------------------------
       ctf-tracer-ora-notif-property section.
           SET ADDRESS OF lk-ctf-property-name TO
               cblte-tnpc-name OF lk-ctf-notif-param-property

           PERFORM VARYING ls-prop-id FROM 1 BY 1
                     UNTIL ws-prop-name(ls-prop-id) = SPACES

               IF ws-prop-name(ls-prop-id) =
                  lk-ctf-property-name
                   (1:cblte-tnpc-namelen OF lk-ctf-notif-param-property)

                   MOVE cblte-tnpc-valint OF lk-ctf-notif-param-property
                        TO ls-prop-value

                   PERFORM apply-ora-property-value
                   EXIT PERFORM
               END-IF
           END-PERFORM
           .

      *****************************************************************
      *    Output trace event
      *****************************************************************
       trace-ora-event section.
           MOVE 78-TRACE-EVENT-FLAGS-NONE TO
                cblte-trcevt-flags OF ctf-trace-event
           MOVE ls-trace-event TO
                cblte-trcevt-event-id OF ctf-trace-event
           MOVE ls-trace-level TO
                cblte-trcevt-level OF ctf-trace-event

           MOVE 0 TO ls-trace-data-count

           EVALUATE ls-trace-event
               WHEN EVENT-CASLOAD
                   PERFORM trace-ora-event-casload
               WHEN EVENT-ORALOAD
                   PERFORM trace-ora-event-oraload
               WHEN EVENT-XAOSW
                   PERFORM trace-ora-event-xaosw
           END-EVALUATE

           MOVE ls-trace-data-count TO
                cblte-trcevt-data-count OF ctf-trace-event

           CALL "CBL_CTF_TRACE" USING BY VALUE     0
                                      BY REFERENCE ctf-tracer-handle
                                      BY REFERENCE ctf-trace-event
           END-CALL

           IF RETURN-CODE NOT = 0
               DISPLAY "CBL_CTF_TRACE (rc = "
                       RETURN-CODE
                       ")"
           END-IF
           .

      *-----------------------------------------------------------------
      *    Set up trace data
      *-----------------------------------------------------------------

       trace-ora-event-casload section.

           IF MFocusCasPtr = BadPtr
              MOVE "casaxlib.so failed to load" TO CasLoadString
           ELSE
              MOVE "casaxlib.so loaded ok" TO CasLoadString
           END-IF

           UNSTRING CasLoadString DELIMITED BY "   " INTO TmpString
                COUNT ctf-trace-event-lens(1)

           SET ctf-trace-event-ptrs(1) TO 
               ADDRESS OF CasLoadString

           MOVE 78-TRACE-EVENT-TYPE-TEXT TO
                ctf-trace-event-types(1)

           ADD 1 TO ls-trace-data-count

           .

       trace-ora-event-oraload section.

           IF OraXaPtr = BadPtr
              MOVE "Oracle libraries failed to load" TO OraLoadString
           ELSE
              MOVE "Oracle libraries loaded ok" TO OraLoadString
           END-IF

           UNSTRING OraLoadString DELIMITED BY "   " INTO TmpString
                COUNT ctf-trace-event-lens(1)

           SET ctf-trace-event-ptrs(1) TO 
               ADDRESS OF OraLoadString

           MOVE 78-TRACE-EVENT-TYPE-TEXT TO
                ctf-trace-event-types(1)

           ADD 1 TO ls-trace-data-count

           .


       trace-ora-event-xaosw section.

           IF OraXaPtr = BadPtr
              MOVE "Oracle XA function failed to load" TO XaoswString
           ELSE
              MOVE "Oracle XA function loaded ok" TO XaoswString
           END-IF

           UNSTRING XaoswString DELIMITED BY "   " INTO TmpString
                COUNT ctf-trace-event-lens(1)

           SET ctf-trace-event-ptrs(1) TO 
               ADDRESS OF XaoswString

           MOVE 78-TRACE-EVENT-TYPE-TEXT TO
                ctf-trace-event-types(1)

           ADD 1 TO ls-trace-data-count

           .

      *--------------------------------------------------------------*
       xa-open SECTION.
       ENTRY esxa-open USING BY REFERENCE lk-open-string
                                 BY VALUE     lk-rmid
                                 BY VALUE     lk-flags.

        *> CUSTOMIZE
        *> If you don't want to make the userID and password visible
        *> within the ES configuration pages, then code the complete
        *> open string here. Note that you must specify the
        *> DB, and AXLIB parameters at minimum.
        *>
        *> Please refer to Oracle documentation for the complete
        *> definition of the XA open string.
        *>
        *> For example: 
        *>
        *> MOVE "Oracle_XA+SesTm=100+SqlNet=DNSName+Acc=P/uid/passwd"
        *>      TO lk-open-string
 

           CALL ORAXA-open-entry USING BY REFERENCE lk-open-string
                                       BY VALUE lk-rmid
                                       BY VALUE lk-flags
                             RETURNING ws-open-rc
           END-CALL

           GOBACK RETURNING ws-open-rc
           .

       xa-close SECTION.
       ENTRY esxa-close USING BY REFERENCE lk-close-string
                                  BY VALUE     lk-rmid
                                  BY VALUE     lk-flags.


           CALL ORAXA-close-entry USING BY REFERENCE lk-close-string
                                        BY VALUE     lk-rmid
                                        BY VALUE     lk-flags
                              RETURNING ws-close-rc
           END-CALL

           GOBACK RETURNING ws-close-rc
           .

       xa-start SECTION.
       ENTRY esxa-start USING BY REFERENCE lk-xid
                                  BY VALUE     lk-rmid
                                  BY VALUE     lk-flags.

           CALL ORAXA-start-entry USING BY REFERENCE lk-xid
                                        BY VALUE     lk-rmid
                                        BY VALUE     lk-flags
                              RETURNING ws-start-rc
           END-CALL

           GOBACK RETURNING ws-start-rc
           .

       xa-end SECTION.
       ENTRY esxa-end USING BY REFERENCE lk-xid
                                BY VALUE     lk-rmid
                                BY VALUE     lk-flags.

           CALL ORAXA-end-entry USING BY REFERENCE lk-xid
                                        BY VALUE     lk-rmid
                                        BY VALUE     lk-flags
                              RETURNING ws-end-rc
           END-CALL

           GOBACK RETURNING ws-end-rc
           .

       xa-rollback SECTION.
       ENTRY esxa-rollback  USING BY REFERENCE lk-xid
                                      BY VALUE     lk-rmid
                                      BY VALUE     lk-flags.

           CALL ORAXA-rollback-entry USING BY REFERENCE lk-xid
                                           BY VALUE     lk-rmid
                                           BY VALUE     lk-flags
                                 RETURNING ws-rollback-rc
           END-CALL

           GOBACK RETURNING ws-rollback-rc
           .

       xa-prepare SECTION.
       ENTRY esxa-prepare USING BY REFERENCE lk-xid
                                    BY VALUE     lk-rmid
                                    BY VALUE     lk-flags.

           CALL ORAXA-prepare-entry USING BY REFERENCE lk-xid
                                           BY VALUE     lk-rmid
                                           BY VALUE     lk-flags
                                 RETURNING ws-prepare-rc
           END-CALL

           GOBACK RETURNING ws-prepare-rc
           .

       xa-commit SECTION.
       ENTRY esxa-commit  USING BY REFERENCE lk-xid
                                    BY VALUE     lk-rmid
                                    BY VALUE     lk-flags.

           CALL ORAXA-commit-entry USING BY REFERENCE lk-xid
                                         BY VALUE     lk-rmid
                                         BY VALUE     lk-flags
                               RETURNING ws-commit-rc
           END-CALL

           GOBACK RETURNING ws-commit-rc
           .

       xa-recover SECTION.
       ENTRY esxa-recover USING BY REFERENCE lk-xid
                                    BY VALUE     lk-rmid
                                    BY VALUE     lk-flags.

           CALL ORAXA-recover-entry USING BY REFERENCE lk-xid
                                         BY VALUE     lk-rmid
                                         BY VALUE     lk-flags
                               RETURNING ws-recover-rc
           END-CALL

           GOBACK RETURNING ws-recover-rc
           .

       xa-forget SECTION.
       ENTRY esxa-forget USING BY REFERENCE lk-xid
                                   BY VALUE     lk-rmid
                                   BY VALUE     lk-flags.

           CALL ORAXA-forget-entry USING BY REFERENCE lk-xid
                                         BY VALUE     lk-rmid
                                         BY VALUE     lk-flags
                               RETURNING ws-forget-rc
           END-CALL

           GOBACK RETURNING ws-forget-rc
           .

       xa-complete SECTION.
       ENTRY esxa-complete USING BY REFERENCE lk-xid
                                     BY VALUE     lk-rmid
                                     BY VALUE     lk-flags.

           CALL ORAXA-complete-entry USING BY REFERENCE lk-xid
                                         BY VALUE     lk-rmid
                                         BY VALUE     lk-flags
                               RETURNING ws-complete-rc
           END-CALL

           GOBACK RETURNING ws-complete-rc
           .

